
module M {
  class Disposer implements System.IDisposable {
    str : string;
    
    public this (str : string) 
    { printf ("I'm being created - %s\n", str);
      this.str <- str; 
    }
    
    public Dispose () : void 
    { printf ("I'm being disposed - %s\n", this.str); }
  }

  public Main () : void {
   
    printf("Testing using...\n");
    def b = Disposer("two");
    using (a = Disposer("one"), b, c = Disposer("three")) {
      printf("Inside\n");
    };
    printf("Tested\n");
  }
}

(*
BEGIN-OUTPUT
Testing using...
I'm being created - two
I'm being created - one
I'm being created - three
Inside
I'm being disposed - three
I'm being disposed - two
I'm being disposed - one
Tested
END-OUTPUT
*)
